
import ttt as ttt
import sys
import os

#Set some important variables for the flash
flashAddOffset = ttt.FLASH_ADD_OFFSET
flashSectorSize = ttt.FLASH_SECTOR_SIZE
flashPageSize = ttt.FLASH_PAGE_SIZE
flashPagesPerSector = ttt.FLASH_PAGES_PER_SECTOR


#Carry out flash command
def doCmd( len):
    ttt.write("FLASH_CMD", len)
    z = ttt.read("STATUS") & 1
    while z != 0:
        z = ttt.read("STATUS") & 1

# enable flash writing
def enableFlashWrite():
    ttt.write( "FLASH_WBUF", 0x06 << 24)
    doCmd( 0)

# wait for write-in-progress =0, return number of cycles to complete
def waitForWriteDone():
    ttt.write( "FLASH_WBUF", 0x05000000)
    doCmd( 1)
    z = ttt.read( "FLASH_RBUF")
    n = 0
    while z & 0x01000000:
        doCmd( 1)
        z = ttt.read( "FLASH_RBUF")
        n = n + 1
    return n
    
# erase a flash sector (sectors are 256k bytes)
def eraseFlashSector( s):
    enableFlashWrite()
    adrs = s * flashSectorSize
    print "Erasing flash sector at address 0x%05x" % (adrs)
    ttt.write( "FLASH_WBUF", 0xD8 << 24 | adrs)
    doCmd( 3)
    waitForWriteDone()

#Retrieve flash id
def getFlashID():
    ttt.write( "FLASH_WBUF", 0x9f000000)
    doCmd( 3)
    return ttt.read("FLASH_RBUF")

#read count bytes from flash
def readFlashData( adrs, count):
    if (count % 4) != 0:
        print "Warning... can only read multiple of 4 bytes"
        return
    words = count / 4
    ttt.write( "FLASH_WBUF", 0x0b << 24 | adrs)
    doCmd( count+4)
    data = []
    for i in xrange( words):
        buff = ttt.read("FLASH_RBUF", i)
        for j in xrange(4):
            d = (buff>>24) & 0xff
            data.append(d)
            buff = buff << 8
    return data  

#print the np flash pages from address add
def printFlashPages(np, add):
    for i in xrange(np):
        data = readFlashData( add+(i*flashPageSize), flashPageSize)
        s = ""
        r = 0
        for j in xrange( flashPageSize):
            s += "%02x " % data[j]
            r = r + 1
            if r == 16:
                r = 0
                print s
                s = ""

# program up to 256 (usually == 256) bytes in a flash page
#   adrs is starting byte address
#   count is number of bytes
def programFlashPage( adrs, count, data):
    if (count % 4) != 0:
        print "Warning... can only program multiple of 4 bytes"
        return
    waitForWriteDone()          # let any previous write complete
    enableFlashWrite()
    ttt.write( "FLASH_WBUF", (0x02 << 24) | adrs)
    offset = 1
    i = 0
    remain = count
    #block=[]
    while remain > 0:
        buff = data[i] << 24 | data[i+1] << 16 | data[i+2] << 8 | data[i+3]
        ttt.write( "FLASH_WBUF", buff, offset)
        i = i + 4
        #block.append(buff)
        offset = offset + 1
        remain = remain - 4
    #ttt.blockWrite("FLASH_WBUF",block,offset)
    doCmd( count+3)
    waitForWriteDone()
