
from flash_cmds import *
import sys

#zero the flash np pages with address offset 
def zeroflash(np,offset):
   kpages=np/flashPagesPerSector
   koffset=offset/flashPagesPerSector/flashPageSize
   remainder=kpages%flashPagesPerSector
   if remainder !=0: kpages +=1
   if(kpages==0): kpages +=1
   for i in xrange(kpages): eraseFlashSector(i+koffset)
   print "\n"

#program flash np pages with address offset, data in dictionary d 
#write data in 256 word blocks in reverse order
def programflash(np,offset,d):
   address=flashPageSize*(np-1)
   for i in xrange(np):
      data=[]
      for j in xrange(flashPageSize):
         data.append(d[address+j])
      #write to flash
      if i==0: print "programming flash at address 0x%05x" % (address+offset)
      if (i+1)%300 ==0: print "programming flash at address 0x%05x" \
          % (address+offset), "\t%02d%% done" % ((i+50)*100/np)
      programFlashPage(address+offset, flashPageSize, data)
      address -= flashPageSize
   print ""

#read back data and verify
def verifyflash(np,offset,d):
   ierr=0
   index=0
   add=0
   i=0
   nreads = np
   while i < nreads:
      if i==0: print "\nverifying flash at address 0x%05x" % (add+offset)
      if (i+1)%300 ==0: print "verifying flash at address 0x%05x" % (add+offset), "\t%02d%% done" % ((i+50)*100/np) 
      R=readFlashData(add+offset,flashPageSize)
      j=0
      while j < flashPageSize and index < np*flashPageSize:
         r=int(R[j])
         if d[index] !=  r:
            print "flash programming error, read no., byte =", j, "at page", i, "wrote", \
                hex(d[index]), "and read back ", hex(r)
            ierr=1
            break
         j +=1
         index +=1
      if ierr == 1: break
      add +=256
      i +=1
   if ierr ==0:
      print "TTT flash successfully verified, no. pages =", np
      return 0
   else:
      return 1
   
#read all the data from file s into dictionary d
#the dictionary key is the address and the value is the byte of data 
def fillDataDict(d,s):
 index=0
 iquit=0
 f=open(s, 'r')
 numlines=0
 while iquit==0:
    #read first character which must be a colon
    x = f.read(1)
    if x != ':' :
        print 'Start char error, expected colon at beginning of line'
        print "stopping flash programming"
        raw_input('\n')
    #read next byte which is number of data bytes in the line of code
    b = int(f.read(2),16)
    #read address 2 bytes in two steps to make checksum easy
    a1 = f.read(2)
    a2 = f.read(2)
    #combine bytes to get address (add)
    add = int(a1+a2,16)
    #read record type 00 is data, 01 is end of file
    #other record types for now we do not care about
    rectyp =int(f.read(2),16)
    i = 0
    data_sum=0
    #loop over data
    while i < b :
        data = int(f.read(2),16)
        data_sum +=data
        if rectyp==0:
           d[index] = data
           index +=1
        i +=1
    numlines += 1
    #read check sum byte
    csum = int(f.read(2),16)
    #checksum
    check = b+ int(a1,16)+int(a2,16) + rectyp +data_sum
    #perform checksum, sum of all bytes inclduding checksum must be zero in the last byte
    check=(check+csum)&0xff
    if check !=0:
       print "check sum error in file", s
       print "stopping flash programming"
       raw_input('\n')
    #read end of line
    burn = f.read(1)
    #check for end of file
    if rectyp == 1: iquit=1
 f.close
 return (0)
